diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/ofdm-ppdu.cc ns-3.43/src/wifi/model/non-ht/ofdm-ppdu.cc
--- ns-3.42/src/wifi/model/non-ht/ofdm-ppdu.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/ofdm-ppdu.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Rediet <getachew.redieteab@orange.com>
  *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
@@ -102,7 +91,7 @@
 }
 
 void
-OfdmPpdu::LSigHeader::SetRate(uint64_t rate, uint16_t channelWidth)
+OfdmPpdu::LSigHeader::SetRate(uint64_t rate, MHz_u channelWidth)
 {
     if (channelWidth == 5)
     {
@@ -155,7 +144,7 @@
 }
 
 uint64_t
-OfdmPpdu::LSigHeader::GetRate(uint16_t channelWidth) const
+OfdmPpdu::LSigHeader::GetRate(MHz_u channelWidth) const
 {
     uint64_t rate = 0;
     switch (m_rate)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-ht/ofdm-ppdu.h ns-3.43/src/wifi/model/non-ht/ofdm-ppdu.h
--- ns-3.42/src/wifi/model/non-ht/ofdm-ppdu.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-ht/ofdm-ppdu.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Rediet <getachew.redieteab@orange.com>
  *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
@@ -59,16 +48,16 @@
          * Fill the RATE field of L-SIG (in bit/s).
          *
          * \param rate the RATE field of L-SIG expressed in bit/s
-         * \param channelWidth the channel width (in MHz)
+         * \param channelWidth the channel width
          */
-        void SetRate(uint64_t rate, uint16_t channelWidth = 20);
+        void SetRate(uint64_t rate, MHz_u channelWidth = 20);
         /**
          * Return the RATE field of L-SIG (in bit/s).
          *
-         * \param channelWidth the channel width (in MHz)
+         * \param channelWidth the channel width
          * \return the RATE field of L-SIG expressed in bit/s
          */
-        uint64_t GetRate(uint16_t channelWidth = 20) const;
+        uint64_t GetRate(MHz_u channelWidth = 20) const;
         /**
          * Fill the LENGTH field of L-SIG (in bytes).
          *
@@ -137,9 +126,9 @@
      */
     virtual void SetTxVectorFromLSigHeader(WifiTxVector& txVector, const LSigHeader& lSig) const;
 
-    uint16_t m_channelWidth; //!< the channel width used to transmit that PPDU in MHz (needed to
-                             //!< distinguish 5 MHz, 10 MHz or 20 MHz PPDUs)
-};                           // class OfdmPpdu
+    MHz_u m_channelWidth; //!< the channel width used to transmit that PPDU
+                          //!< (needed to distinguish 5 MHz, 10 MHz or 20 MHz PPDUs)
+};                        // class OfdmPpdu
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-inheritance.cc ns-3.43/src/wifi/model/non-inheritance.cc
--- ns-3.42/src/wifi/model/non-inheritance.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-inheritance.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/non-inheritance.h ns-3.43/src/wifi/model/non-inheritance.h
--- ns-3.42/src/wifi/model/non-inheritance.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/non-inheritance.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/originator-block-ack-agreement.cc ns-3.43/src/wifi/model/originator-block-ack-agreement.cc
--- ns-3.42/src/wifi/model/originator-block-ack-agreement.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/originator-block-ack-agreement.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009, 2010 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mirko Banchi <mk.banchi@gmail.com>
  *          Tommaso Pecorella <tommaso.pecorella@unifi.it>
@@ -99,6 +88,30 @@
     m_txWindow.Init(m_startingSeq, m_bufferSize);
 }
 
+bool
+OriginatorBlockAckAgreement::AllAckedMpdusInTxWindow(const std::set<uint16_t>& seqNumbers) const
+{
+    std::set<std::size_t> distances;
+    for (const auto seqN : seqNumbers)
+    {
+        distances.insert(GetDistance(seqN));
+    }
+
+    for (std::size_t i = 0; i < m_txWindow.GetWinSize(); ++i)
+    {
+        if (distances.contains(i))
+        {
+            continue; // this is one of the positions to ignore
+        }
+        if (!m_txWindow.At(i))
+        {
+            return false; // this position is available or contains an unacknowledged MPDU
+        }
+    }
+    NS_LOG_INFO("TX window is blocked");
+    return true;
+}
+
 void
 OriginatorBlockAckAgreement::AdvanceTxWindow()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/originator-block-ack-agreement.h ns-3.43/src/wifi/model/originator-block-ack-agreement.h
--- ns-3.42/src/wifi/model/originator-block-ack-agreement.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/originator-block-ack-agreement.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009, 2010 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mirko Banchi <mk.banchi@gmail.com>
  * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
@@ -23,6 +12,8 @@
 #include "block-ack-agreement.h"
 #include "block-ack-window.h"
 
+#include <set>
+
 class OriginatorBlockAckWindowTest;
 
 namespace ns3
@@ -35,21 +26,29 @@
  * Maintains the state and information about transmitted MPDUs with Ack Policy set to Block Ack
  * for an originator station. The state diagram is as follows:
  *
-   \verbatim
-    /------------\ send ADDBARequest ----------------
-    |   START    |------------------>|   PENDING    |-------
-    \------------/                   ----------------       \
-          ^            receive     /        |                \
-          |        ADDBAResponse  /         |                 \
-          |          (failure)   v          |                  \
-          |        ---------------          |                   --------------------->
- ---------------- |        |  REJECTED   |          |          receive ADDBAResponse (success)  |
- ESTABLISHED | |        ---------------          |      no            -------------------->
- ---------------- |           receive    ^          | ADDBAResponse     / |        ADDBAResponse \
- |                  / |          (failure)     \        v                 / | ---------------- /
-          |-------------------------|   NO_REPLY   |---------
-            Reset after timeout     ----------------
+ */
+// clang-format off
+/**
+ * \verbatim
+   /------------\ send ADDBARequest ----------------
+   |   START    |------------------>|   PENDING    |-------
+   \------------/                   ----------------       \
+         ^            receive     /        |                \
+         |        ADDBAResponse  /         |                 \
+         |          (failure)   v          |                  \
+         |        ---------------          |                   --------------------->  ----------------
+         |        |  REJECTED   |          |          receive ADDBAResponse (success)  |  ESTABLISHED |
+         |        ---------------          |      no            -------------------->  ----------------
+         |           receive    ^          | ADDBAResponse     /
+         |        ADDBAResponse  \         |                  /
+         |          (failure)     \        v                 /
+         |                         ----------------         /
+         |-------------------------|   NO_REPLY   |---------
+           Reset after timeout     ----------------
    \endverbatim
+*/
+// clang-format on
+/**
  *
  * See also OriginatorBlockAckAgreement::State
  */
@@ -193,6 +192,16 @@
      */
     void NotifyDiscardedMpdu(Ptr<const WifiMpdu> mpdu);
 
+    /**
+     * Check whether all the MPDUs in the TX window other than the given ones have been already
+     * acknowledged.
+     *
+     * \param seqNumbers the sequence numbers of the given MPDUs
+     * \return whether all the MPDUs in the TX window other than the given ones have been already
+     *         acknowledged
+     */
+    bool AllAckedMpdusInTxWindow(const std::set<uint16_t>& seqNumbers) const;
+
   private:
     /**
      * Advance the transmit window so that the starting sequence number is the
